//    RW Props
// ==============
// Various Props, Gadgets & Accessories for Robowaifus : Anim Avatars edition
// -Part of the RW Foundations suite of libraries

// Filename: ./src/chibitsu/props/props.cpp
// -Definitions of the baseline RW Props library subsystem

#pragma once

#include "incls_all.hpp"

namespace rw::chibitsu::props {

//------------------------------------------------------------------------------
//   CONFETTI
//------------------------------------------------------------------------------
Confetti_b::Confetti_b() : Confetti_b{"confetti_b_obj"} {}

//------------------------------------------------------------------------------
Confetti_b::Confetti_b(std::string const& handle) : RW{handle, Type::Prop} {
  stamp("Confetti_b()");
}

//------------------------------------------------------------------------------
Confetti::Confetti() : Confetti{"confetti_obj"} {}

//------------------------------------------------------------------------------
Confetti::Confetti(std::string const& handle) : Confetti_b{handle} {
  stamp("Confetti()");
}

//------------------------------------------------------------------------------
void Confetti::toss() {
  stamp("toss()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   DUSTPAN
//------------------------------------------------------------------------------
Dustpan_b::Dustpan_b() : Dustpan_b{"dustpan_b_obj"} {}

//------------------------------------------------------------------------------
Dustpan_b::Dustpan_b(std::string const& handle) : RW{handle} {
  stamp("Dustpan_b()");
}

//------------------------------------------------------------------------------
Dustpan::Dustpan() : Dustpan{"dustpan_obj"} {}

//------------------------------------------------------------------------------
Dustpan::Dustpan(std::string const& handle) : Dustpan_b{handle} {
  stamp("Dustpan()");
}

//------------------------------------------------------------------------------
void Dustpan::scoop() {
  stamp("scoop()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   FLAGS
//------------------------------------------------------------------------------
Flags_b::Flags_b() : Flags_b{"flags_b_obj"} {}

//------------------------------------------------------------------------------
Flags_b::Flags_b(std::string const& handle) : RW{handle} {
  stamp("Flags_b()");
}

//------------------------------------------------------------------------------
Flags::Flags() : Flags{"flags_obj"} {}

//------------------------------------------------------------------------------
Flags::Flags(std::string const& handle) : Flags_b{handle} {
  stamp("Flags()");
}

//------------------------------------------------------------------------------
void Flags::wave() {
  stamp("wave()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   POMPOMS
//------------------------------------------------------------------------------
Pompoms_b::Pompoms_b() : Pompoms_b{"pompoms_b_obj"} {}

//------------------------------------------------------------------------------
Pompoms_b::Pompoms_b(std::string const& handle) : RW{handle} {
  stamp("Pompoms_b()");
}

//------------------------------------------------------------------------------
Pompoms::Pompoms() : Pompoms{"pompoms_obj"} {}

//------------------------------------------------------------------------------
Pompoms::Pompoms(std::string const& handle) : Pompoms_b{handle} {
  stamp("Pompoms()");
}

//------------------------------------------------------------------------------
void Pompoms::cheer() {
  stamp("cheer()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   TAMBOURINE
//------------------------------------------------------------------------------
Tambourine_b::Tambourine_b() : Tambourine_b{"tambourine_b_obj"} {}

//------------------------------------------------------------------------------
Tambourine_b::Tambourine_b(std::string const& handle) : RW{handle} {
  stamp("Tambourine_b()");
}

//------------------------------------------------------------------------------
Tambourine::Tambourine() : Tambourine{"tambourine_obj"} {}

//------------------------------------------------------------------------------
Tambourine::Tambourine(std::string const& handle) : Tambourine_b{handle} {
  stamp("Tambourine()");
}

//------------------------------------------------------------------------------
void Tambourine::shake() {
  stamp("shake()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   WHISK
//------------------------------------------------------------------------------
Whisk_b::Whisk_b() : Whisk_b{"whisk_b_obj"} {}

//------------------------------------------------------------------------------
Whisk_b::Whisk_b(std::string const& handle) : RW{handle} {
  stamp("Whisk_b()");
}

//------------------------------------------------------------------------------
Whisk::Whisk() : Whisk{"whisk_obj"} {}

//------------------------------------------------------------------------------
Whisk::Whisk(std::string const& handle) : Whisk_b{handle} {
  stamp("Whisk()");
}

//------------------------------------------------------------------------------
void Whisk::sweep() {
  stamp("sweep()");

  // DESIGN: redirect this into a Sumomo impl instead ?
}

//------------------------------------------------------------------------------
//   WHISTLE
//------------------------------------------------------------------------------
Whistle_b::Whistle_b() : Whistle_b{"whistle_b_obj"} {}

//------------------------------------------------------------------------------
Whistle_b::Whistle_b(std::string const& handle) : RW{handle} {
  stamp("Whistle_b()");
}

//------------------------------------------------------------------------------
Whistle::Whistle() : Whistle{"whistle_obj"} {}

//------------------------------------------------------------------------------
Whistle::Whistle(std::string const& handle) : Whistle_b{handle} {
  stamp("Whistle()");
}

//------------------------------------------------------------------------------
void Whistle::tweet() {
  stamp("tweet()");

  // DESIGN: redirect all this into a Sumomo impl instead ?
  // -eg, replace the puts() with a call to here, and move everything else there
  //
  // if (tip.tag.has("sumomo")) {
  // bones_.do_whistle_anticipation();
  // face_.scrunch_pose();
  // bones_.do_whistle();
  puts("TWWEEEEEEEEEEEET!!");
  // hearsay_.do_whistle_tweet(2s);
  // bones_.recover_from_whistle();
  // face_.bright_smile();
  // }
}

}  // namespace rw::chibitsu::props

//    --=^=--

// "______"

// rw_chibitsu_lib.v220319
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
